searchNodes=[{"doc":"Check if your password has been pwned.","ref":"Pwned.html","title":"Pwned","type":"module"},{"doc":"This uses API v3 of the have i been pwned? to check if an email has appeared in a data breach. It returns the total count of appearances.It also requires a purchased hibp-api-key, and implements a 12-factor methodology by accessing the hibp-api-key from the system's environment variables.Examples iex&gt; Pwned.check_email(&quot;test123@example.com&quot;) iex Pwned.check_email(&quot;Z76okiy2X1m5PFud8iPUQGqusShCJhg@example.com&quot;)","ref":"Pwned.html#check_email/1","title":"Pwned.check_email/1","type":"function"},{"doc":"It uses have i been pwned? to verify if a password has appeared in a data breach. In order to protect the value of the source password being searched the value is not sended through the network.Examplesiex&gt; Pwned.check_password(&quot;P@ssw0rd&quot;) {:ok, 47205} iex&gt; Pwned.check_password(&quot;Z76okiy2X1m5PFud8iPUQGqusShCJhg&quot;) {:ok, false}","ref":"Pwned.html#check_password/1","title":"Pwned.check_password/1","type":"function"},{"doc":"Uses the API V3 pwnedpasswords to check if a password has been pwned.Updated to include padding to increase privacy.","ref":"Pwned.Range.HTTPClient.html","title":"Pwned.Range.HTTPClient","type":"module"},{"doc":"Callback implementation for c:Pwned.Range.get/1.","ref":"Pwned.Range.HTTPClient.html#get/1","title":"Pwned.Range.HTTPClient.get/1","type":"function"},{"doc":"Checks if a given email has been pwned using the HaveIBeenPwned? API v3 breachedaccounts service.Requires a purchased hibp-api_key.","ref":"Pwned.Utils.APIClient.html","title":"Pwned.Utils.APIClient","type":"module"},{"doc":"","ref":"Pwned.Utils.APIClient.html#expected_api_response_errors/1","title":"Pwned.Utils.APIClient.expected_api_response_errors/1","type":"function"},{"doc":"","ref":"Pwned.Utils.APIClient.html#get/1","title":"Pwned.Utils.APIClient.get/1","type":"function"},{"doc":"Functions to flatten nested email lists from breachedaccount API v3 response.","ref":"Pwned.Utils.EmailFlattener.html","title":"Pwned.Utils.EmailFlattener","type":"module"},{"doc":"","ref":"Pwned.Utils.EmailFlattener.html#flatten/1","title":"Pwned.Utils.EmailFlattener.flatten/1","type":"function"},{"doc":"Functions for reducing the email list returned from the breachedacocunt API v3.","ref":"Pwned.Utils.EmailReducer.html","title":"Pwned.Utils.EmailReducer","type":"module"},{"doc":"Reduces an email list and returns the integer sum.Exampleiex&gt; reduce_email_list(email_list) iex&gt; iex&gt; 4893554722","ref":"Pwned.Utils.EmailReducer.html#reduce_email_list/1","title":"Pwned.Utils.EmailReducer.reduce_email_list/1","type":"function"},{"doc":"Pwned by Core Theory A simple application to check if an email or password has been pwned using the HaveIbeenPwned? API v3.EmailsThis library currently implements simple email checking against data breaches with the HaveIBeenPwned? API v3. It requires a purchased api-key in order to work.The Pwned.check_email/1 function returns the total number of times an email address has appeared in known data breaches, or an &quot;email not pwned&quot; message.PasswordsThis library uses HaveIBeenPwned? to verify if a password has appeared in a data breach. In order to protect the value of the source password being searched, the value is not sent through the network. Instead it uses a k-Anonymity model that allows a password to be searched for by partial hash. This allows the first 5 characters of a SHA-1 password hash to be passed to the API. Then, it searches the results of the response for the presence of the source hash. If the source hash is not found, then the password does not exist in the data set.Additionally, we implement padding to further protect the privacy of the password source hash in accordance with password padding in API v3.","ref":"readme.html","title":"Pwned by Core Theory","type":"extras"},{"doc":"Dependencies Install Usage Changelog Contributing Further Reading License Notice Special Thanks","ref":"readme.html#table-of-contents","title":"Pwned by Core Theory - Table of Contents","type":"extras"},{"doc":"This package requires httpoison v1.8. If you have v1.7 in your mix.lock file, then you will need to update it to 1.8 to successfully run mix deps.get.","ref":"readme.html#dependencies","title":"Pwned by Core Theory - Dependencies","type":"extras"},{"doc":"RecommendedThis package can be installed by adding :pwned_coretheory to your list of dependencies in mix.exs:defp deps do [ ... {:pwned_coretheory, &quot;~&gt; 1.5&quot;}, ] endThen, run mix deps.get. Additionally, run mix deps.update pwned_coretheory occasionally to ensure you have the latest release.Running on masterIf you would like to run on the master branch, then update your dependencies as such:defp deps do [ ... {:pwned_coretheory, github: &quot;coretheory/pwned_coretheory&quot;}, ] end","ref":"readme.html#install","title":"Pwned by Core Theory - Install","type":"extras"},{"doc":"Usage is incredibly simple and straightforward. You can check if an email or password has been pwned with calls to their respective functions.In the case of checking for an email, you will need to have purchased a hibp-api-key.You can use this library for password checking without the need for an API key. However, if this is the case, then keep in mind that not all tests will pass. If you do not need email checking, then we encourage you to use the pwned library by Thiago Santos.Check for pwned passwordsTo check whether a password has been pwned you can make a simple call to the Pwned.check_password/1 function:iex&gt; Pwned.check_password(&quot;P@ssw0rd&quot;) {:ok, 47205} iex&gt; Pwned.check_password(&quot;Z76okiy2X1m5PFud8iPUQGqusShCJhg&quot;) {:ok, false}When implementing in an application, we can use a straightforward case statement like this:case Pwned.check_password(&quot;somepassword&quot;) do {:ok, false} -&gt; IO.puts(&quot;Good news — no pwnage found!&quot;) {:ok, count} -&gt; IO.puts(&quot;Oh, no! This password appeared \#{count} times in data breaches.&quot;) :error -&gt; IO.puts(&quot;Something went wrong.&quot;) endCheck for pwned emailsFirst, let's make sure our hibp-api-key is ready to go.Purchase your hibp-api-key and add it to an environment fileYou will first need to purchase a hibp-api-key from haveibeenpwned?.Then, create a .env file at the root of your project (e.g. beside your .gitignore. Be sure to update your .gitignore file to ignore environment files: *.env. Once you are certain that you will not be pushing your environment files up to a source control repository, add your purchased hibp-api-key to your .env file: export HIBP_API_KEY=your_hibp_api_key. Next, you'll want to run source .env from your terminal.For production, you'll want to have your hibp-api-key safely stored in your production host's environment variables configuration with the key: HIBP_API_KEY.Lastly, you can easily configure the :user_agent for the HIBP API, like so:# In your config.exs. config :pwned_coretheory, user_agent: &quot;YourApp Pwned Client&quot;We highly recommend you set the configuration as it is good practice and informs the HaveIBeenPwned? service that it is your application accessing the data and not a spammer or malicious account.Checking emailsTo check whether an email has been pwned you can make a simple call to the Pwned.check_email/1 function:iex&gt; Pwned.check_email(&quot;test123@example.com&quot;) {:pwned_email, 4893554722} iex&gt; Pwned.check_email(&quot;Z76okiy2X1m5PFud8iPUQGqusShCJhg@example.com&quot;) {:safe_email, &quot;email not pwned&quot;}When implementing in an application, we can use a straightforward case statement like this:case Pwned.check_email(&quot;test123@exmaple.com&quot;) do {:safe_email, message} -&gt; IO.puts(message) {:pwned_email, pwned_count} -&gt; IO.puts(&quot;Ohh, sorry! This email has appeared \#{pwned_count} times in data breaches.&quot;) {:error, message} -&gt; IO.puts(&quot;An error occurred: &quot; &lt;&gt; message) :error -&gt; IO.puts(&quot;Something went wrong.&quot;) end","ref":"readme.html#usage","title":"Pwned by Core Theory - Usage","type":"extras"},{"doc":"See the changelog file.","ref":"readme.html#changelog","title":"Pwned by Core Theory - Changelog","type":"extras"},{"doc":"See the contributing file.","ref":"readme.html#contributing","title":"Pwned by Core Theory - Contributing","type":"extras"},{"doc":"See the further reading file.","ref":"readme.html#further-reading","title":"Pwned by Core Theory - Further Reading","type":"extras"},{"doc":"Apache License, Version 2.0 © 2021 Core Theory, Inc.","ref":"readme.html#license","title":"Pwned by Core Theory - License","type":"extras"},{"doc":"This is a modified version of the pwned package © @thiamsantos.","ref":"readme.html#notice","title":"Pwned by Core Theory - Notice","type":"extras"},{"doc":"This extension was built from the simple and wonderful package, pwned, by Thiago Santos. ♥","ref":"readme.html#special-thanks","title":"Pwned by Core Theory - Special thanks","type":"extras"},{"doc":"ChangelogThis is the changelog for Pwned by Core Theory.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"EnhancementsFormat changelog.Add further reading section with notes on rate limiting and additional resources.","ref":"changelog.html#1-5-1-2021-01-27","title":"Changelog - 1.5.1 (2021-01-27)","type":"extras"},{"doc":"EnhancementsReplace unsafe runtime environment call with compile time call in api_client.ex.Refactor api_client.ex for clarity, performance, and maintainability.","ref":"changelog.html#1-5-0-2021-01-27","title":"Changelog - 1.5.0 (2021-01-27)","type":"extras"},{"doc":"EnhancementsAdd hibp-api-key to CI to enable checking email and password tests.","ref":"changelog.html#1-2-4-2021-01-26","title":"Changelog - 1.2.4 (2021-01-26)","type":"extras"},{"doc":"EnhancementsAdd default for application environment :user_agent and ability to override in 3rd party application config files.Add usage explanation for setting the :user_agent in 3rd party applications.Add @moduledoc to Pwned.APIClient.","ref":"changelog.html#1-2-3-2021-01-26","title":"Changelog - 1.2.3 (2021-01-26)","type":"extras"},{"doc":"EnhancementsAdd CHANGELOG.md file.","ref":"changelog.html#1-2-2-2021-01-26","title":"Changelog - 1.2.2 (2021-01-26)","type":"extras"},{"doc":"Bug fixesUpdate application name to match :pwned_coretheory. Previous application name mismatch was causing Pwned.check_email(email) to return {:error, &quot;unauthorized api key&quot;} with valid key.","ref":"changelog.html#1-2-1-2021-01-26","title":"Changelog - 1.2.1 (2021-01-26)","type":"extras"},{"doc":"Contributing to pwned_coretheoryThis is an extension of the original pwned package by Thiago Santos.Thank you for taking the time and effort to contribute! Now, take a moment to be sure your contributions make sense to everyone else. These are just guidelines, not rules. Use your best judgment, and feel free to propose changes to this document in a pull request.","ref":"contributing.html","title":"Contributing to pwned_coretheory","type":"extras"},{"doc":"Found a problem? Want a new feature? First of all see if your issue or idea has already been reported. If don't, just open a new clear and descriptive issue.","ref":"contributing.html#reporting-issues","title":"Contributing to pwned_coretheory - Reporting Issues","type":"extras"},{"doc":"Pull requests are the greatest contributions, so be sure they are focused in scope, and do avoid unrelated commits. And submit your pull request after making sure that all tests pass and they are covering 100% of the code.Fork it!Clone your fork: git clone https://github.com/&lt;your-username&gt;/pwned_coretheoryNavigate to the newly cloned directory: cd pwned_coretheoryCreate a new branch for the new feature: git checkout -b my-new-featureInstall the tools necessary for development: npm installMake your changes.Commit your changes: git commit -am 'Add some feature'Push to the branch: git push origin my-new-featureSubmit a pull request with full remarks documenting your changes.","ref":"contributing.html#submitting-pull-requests","title":"Contributing to pwned_coretheory - Submitting pull requests","type":"extras"},{"doc":"Every time you write a test, remember to answer all the questions:What are you testing?What should it do?What is the actual output?What is the expected output?How can the test be reproduced?","ref":"contributing.html#testing","title":"Contributing to pwned_coretheory - Testing","type":"extras"},{"doc":"Further ReadingAdditional notes on working with this package and the HaveIBeenPwned? API.","ref":"further_reading.html","title":"Further Reading","type":"extras"},{"doc":"The HaveIBeenPwned? API v3 features rate limiting per Troy Hunt's explanation. The service is rate limited at 1500 milliseconds, meaning that any purchased hibp-api-key may make one request per 1500 milliseconds.For this reason, it is best to set a :debounce option on your request with at least 100 milliseconds added to the base rate limit. In a Phoenix application using Live View, with 200 milliseconds added to the base rate, this might look like:#In your application&#39;s file.html.leex &lt;%= f = form_for @changeset, &quot;#&quot;, [phx_change: :validate, phx_submit: :save] %&gt; &lt;%= email_input f, :email, phx_debounce: &quot;1700&quot;, required: true %&gt; &lt;%= submit &quot;Register&quot;, phx_disable_with: &quot;Registering...&quot; %&gt; &lt;/form&gt;","ref":"further_reading.html#rate-limiting","title":"Further Reading - Rate Limiting","type":"extras"},{"doc":"We recommend reading through the HaveIBeenPwned? API documentation if you are curious to learn more.","ref":"further_reading.html#additional-resources","title":"Further Reading - Additional resources","type":"extras"},{"doc":"LicenseCopyright 2021 Core Theory, Inc. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]